"use strict";

exports.__esModule = true;
exports.enqueueRender = enqueueRender;
exports.rerender = rerender;
var _options = _interopRequireDefault(require("./options"));
var _util = require("./util");
var _component = require("./vdom/component");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
/** Managed queue of dirty components to be re-rendered */

var items = [];
function enqueueRender(component) {
  if (!component._dirty && (component._dirty = true) && items.push(component) == 1) {
    (_options.default.debounceRendering || _util.defer)(rerender);
  }
}
function rerender() {
  var p,
    list = items;
  items = [];
  while (p = list.pop()) {
    if (p._dirty) (0, _component.renderComponent)(p);
  }
}